from discord.ext import commands
import discord
import animals


class AnimalFunctions(commands.Cog):
    def __init__(self, bot):
        self.bot: commands.Bot = bot

    @commands.slash_command(
        guild_ids=None, name="redpanda", description="Posts a photo of a redpanda"
    )
    async def redpanda(self, ctx: commands.Context):
        await ctx.respond(animals.get_red_panda())

    @commands.slash_command(
        guild_ids=None, name="panda", description="Posts a photo of a panda"
    )
    async def panda(self, ctx: commands.Context):
        await ctx.respond(animals.get_panda())

    @commands.slash_command(
        guild_ids=None, name="koala", description="Posts a photo of a koala"
    )
    async def koala(self, ctx: commands.Context):
        await ctx.respond(animals.get_koala())

    @commands.slash_command(
        guild_ids=None, name="racoon", description="Posts a photo of a racoon"
    )
    async def racoon(self, ctx: commands.Context):
        await ctx.respond(animals.get_racoon())

    @commands.slash_command(
        guild_ids=None, name="fox", description="Posts a photo of a fox"
    )
    async def fox(self, ctx: commands.Context):
        await ctx.respond(animals.get_fox())

    @commands.slash_command(
        guild_ids=None, name="cat", description="Posts a photo of a cat"
    )
    async def cat(self, ctx: commands.Context):
        await ctx.respond(animals.get_cat())

    @commands.slash_command(
        guild_ids=None, name="kangaroo", description="Posts a photo of a kangaroo"
    )
    async def kangaroo(self, ctx: commands.Context):
        await ctx.respond(animals.get_kangaroo())

    @commands.slash_command(
        guild_ids=None, name="dog", description="Posts a photo of a dog"
    )
    async def dog(self, ctx: commands.Context):
        await ctx.respond(animals.get_dog())

    @commands.slash_command(
        guild_ids=None, name="sheeb", description="Posts a photo of a sheeb"
    )
    async def sheeb(self, ctx: commands.Context):
        await ctx.respond(animals.random_sheeb())

    @commands.slash_command(
        guild_ids=None, name="birb", description="Posts a photo of a birb"
    )
    async def birb(self, ctx: commands.Context):
        await ctx.respond(animals.get_birb())

    @commands.slash_command(
        guild_ids=None, name="cowboy", description="Posts a photo of a bad dog"
    )
    async def cowboy(self, ctx: commands.Context):
        await ctx.respond(animals.cowboy())

    @commands.slash_command(
        guild_ids=None,
        name="dale",
        description="Posts a photo of the goodest boy. Rest in power king",
    )
    async def dale(self, ctx: commands.Context):
        await ctx.defer()
        await ctx.send_followup(file=discord.File(animals.dale()))

    @commands.slash_command(
        guild_ids=None, name="rat", description="Posts a photo of a rat"
    )
    async def rat(self, ctx: commands.Context):
        await ctx.respond(animals.get_rat())

    @commands.slash_command(
        guild_ids=None, name="corgi", description="Posts a photo of a corgi"
    )
    async def corgi(self, ctx: commands.Context):
        await ctx.respond(animals.get_corgi())


def setup(bot):
    bot.add_cog(AnimalFunctions(bot))
